## Script (Python) "getDictWeekbyhour"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=Get dictionary of weekbyhour view info for calendar
##
"""
returns a dictionary of useful objects for the Weekbyhour view  

modified for CalendarX 0.4.7(alpha) to extend dayStart by one minute not one second
Released under the GPL (see LICENSE.txt)
"""
request = container.REQUEST

#get the common view dictionary (ALL views must gather this info)
dict = context.getDictCommon('weekbyhour')

#retrieve from dict for use in queries
weekviewstarthour = dict['viewstarthour']
weekviewendhour = dict['viewendhour']
startDate = dict['startDate']
endDate = dict['endDate']
xmy = dict['xmy']
xsub = dict['xsub']
xpub = dict['xpub']
xcrt = dict['xcrt']



#create the continuing events query
#  (noncontinuing events are events that have a start during the viewable week)
continuingEvents =    []
noncontinuingEvents = []
for dayOfWeek in range(7):
    dayStart = startDate + dayOfWeek
    if dayOfWeek == 0:
        dayStart = DateTime(str(dayStart.year())+'/'+str(dayStart.month())+'/'+str(dayStart.day())+' '+str(dayStart.hour())+':01:00')
    dayEnd = DateTime(str(dayStart.year())+'/'+str(dayStart.month())+'/'+str(dayStart.day())+' '+str(weekviewendhour - 1)+ ':59:59')
    daysEventsBetween =   context.getCXEventsBetween(dayStart, dayEnd, xmy, xsub, xpub, xcrt)
    noncontinuingEvents += daysEventsBetween
    daysEventsBefore =    context.getCXEventsBefore(dayStart, xmy, xsub, xpub, xcrt)
    continuingEvents += daysEventsBefore

continuingEvents =    context.queriesUnique(continuingEvents)
noncontinuingEvents = context.queriesUnique(noncontinuingEvents)
continuingEvents =    context.queriesSubtract(continuingEvents,noncontinuingEvents)



#create a laterthan events query
#make sure that these events are not also showing up in other categories above
laterEvents =    []
for dayOfWeek in range(7):
    dayStart = startDate + dayOfWeek
    if weekviewendhour == 24:
        eveStart = DateTime(str(dayStart.year())+'/'+str(dayStart.month())+'/'+str(dayStart.day())+' '+str(weekviewendhour-1)+ ':59:59')
    else:
        eveStart = DateTime(str(dayStart.year())+'/'+str(dayStart.month())+'/'+str(dayStart.day())+' '+str(weekviewendhour)+ ':00:00')
    eveEnd = startDate + 1 + dayOfWeek
    eveEventsBetween =   context.getCXEventsBetween(eveStart, eveEnd, xmy, xsub, xpub, xcrt)
    laterEvents += eveEventsBetween

laterEvents =    context.queriesUnique(laterEvents)
laterEvents =    context.queriesSubtract(laterEvents,continuingEvents)
laterEvents =    context.queriesSubtract(laterEvents,noncontinuingEvents)




#marshall this view's new parameters into the dictionary
dict['weekviewstarthour'] = weekviewstarthour
dict['weekviewendhour'] = weekviewendhour
dict['continuingEvents'] = continuingEvents
dict['laterEvents'] = laterEvents


return dict

